/* $Id: ListenSocket4.C,v 1.1.1.1 2003/01/23 05:29:37 sunday Exp $
 * Copyright (c) 2002, 2003 Joe Sunday <sunday@csh.rit.edu>
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Description:
 *   ListenSocket for IPv4 traffic (Deprecated by ListenSocket6)
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>

#include "ListenSocket4.h"

ListenSocket4::ListenSocket4( unsigned int port ) throw( ListenSocket::Error ) :
    ListenSocket::ListenSocket( PF_INET, SOCK_STREAM ) 
{
    struct sockaddr_in saddr;
    bzero( &saddr, sizeof( saddr ) ); 
    saddr.sin_len = sizeof( saddr );
    saddr.sin_family = AF_INET;
    saddr.sin_port = htons( port );
    saddr.sin_addr.s_addr = INADDR_ANY;

    if( bind( getFd(), (struct sockaddr*)&saddr, sizeof( saddr ) ) ) {
        perror( "bind()" );
        throw( Error( errno ) );
    }

    if( listen( getFd(), 5 ) ) {
        perror( "listen()" );
        throw( Error( errno ) );
    }
}

ClientSocket* ListenSocket4::accept() {
    struct sockaddr_in saddr; 
    socklen_t alen( sizeof( saddr ) );
    int s = ::accept( getFd(), (struct sockaddr*)&saddr, &alen );
    #ifdef _DEBUG 
    printf( "Accepted Connection\n" );
    #endif
    return new ClientSocket( s );
}
