/* $Id: Song.C,v 1.1.1.1 2003/01/23 05:29:37 sunday Exp $
 * Copyright (c) 2002, 2003 Joe Sunday <sunday@csh.rit.edu>
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Description:
 *   Container class for song database results.
 *
 */

#include <string.h>
#include <stdlib.h>
#include "Song.h"

Song::Song( unsigned int album, unsigned int track, 
  const char *atitle, const char *ttitle, const char *artist,
  double length ) :
  a( album ),
  t( track ),
  l( length )
{
    at = strdup( atitle );
    tt = strdup( ttitle );
    art = strdup( artist );
}

Song::~Song() {
    free( at );
    free( tt );
    free( art );
}

unsigned int Song::GetAlbum() const {
    return a;
}

unsigned int Song::GetTrack() const {
    return t;
}

const char *Song::GetAlbumTitle() const { 
    return at;
}

const char *Song::GetTitle() const {
    return tt;
}

const char *Song::GetArtist() const {
    return art;
}

double Song::GetLength() const {
    return l;
}



