#!/usr/bin/perl
# $Id: rip.pl,v 1.1.1.1 2003/01/23 05:29:37 sunday Exp $

# Config options
my $fileroot = '/music';
my $cddevice = '/dev/acd0c';

# Script begin
use DBI;

my $dbh = DBI->connect( 'dbi:Pg:dbname=ogg;host=localhost', 'media', '', 
    {RaiseError => 1, AutoCommit => 0} ) || die "Couldn't connect to database";

#
# SQL Declarations
#
my $sql = qq{
    INSERT INTO albums( title, artist ) 
      VALUES( ?, ? )
};
my $album_sth = $dbh->prepare( $sql );

$sql = qq{ 
    INSERT INTO tracks( album, track, title, artist, length) 
      VALUES( ?, ?, ?, ?, ? )
};
my $track_sth = $dbh->prepare( $sql );

$sql = qq{
    SELECT id FROM albums WHERE oid = ?
};
my $aid_sth = $dbh->prepare( $sql );

#
# Input Album Info
#
print "Album Title: ";
$album = <STDIN>;

print "Artist (enter 'Various' for compilations): ";
$artist = <STDIN>;

print "Number of tracks: ";
$ntracks = <STDIN>;

chomp $album;
chomp $artist;
chomp $ntracks;

for( $i = 1; $i <= $ntracks; $i++ ) {
    print "Title for track $i: ";
    $track_title = <STDIN>;
    chomp $track_title;

    if( $artist =~ /^[Vv][Aa][Rr][Ii][Oo][Uu][Ss]$/ ) {
        print "Artist for track $i: ";
        $track_artist = <STDIN>;
        chomp $track_artist;
    } else {
        $track_artist = $artist;
    }

    $track = {};
    $track->{title} = $track_title;
    $track->{artist} = $track_artist;
    $track->{number} = $i;
    push @tracks, $track;
}

printf( "Proceed? [y/N] " );
$input = <STDIN>;
if( !( $input =~ /^[Yy]/ ) ) {
    die;
}

#
# Create a new album and get the album number
#
$res = $album_sth->execute( $album, $artist );
$res = $aid_sth->execute( $album_sth->{pg_oid_status} );
($albumId) = $aid_sth->fetchrow_array();
$aid_sth->finish();
$a = sprintf "%.8x", ($albumId);
printf( "Creating Album %s\n", $a );
$res = system( "mkdir $fileroot/$a" );

for $t ( @tracks ) {
    next if ( !$t->{title} );
    $tn = sprintf "%.2x",( $t->{number} );
    print "Track:  $t->{number} ($tn)\n";
    print "Title:  $t->{title}\n";
    print "Artist: $t->{artist}\n";
    $res = system( "dagrab -d $device -f cdda.wav -n 200 $t->{number}" );
    if( $res ) {
        cleanup( 'dagrab' );
    }

    $res = system( "oggenc -q 4 -o $fileroot/$a/$tn.ogg cdda.wav" );
    if( $res ) {
        cleanup( 'oggenc' );
    }

    open INFO, "ogginfo $fileroot/$a/$tn.ogg |";
    while( <INFO> ) {
        if( /Playback length: ([\d\:\w]+)/ ) {
            $l = $1;
            break;
        }
    }

    $res = $track_sth->execute( $albumId, $t->{number}, $t->{title}, $t->{artist}, $l );
    
} 
$dbh->commit();
$dbh->disconnect();

sub cleanup
{
    ($action) = @_;
    print( "$action failed, aborting..\n" );
    $dbh->rollback();
    system( "rm -rf $fileroot/$a" );
    $dbh->disconnect();
    exit 1;
}
 
